ALK/Controllers/MyController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using ALK.Models;

namespace ALK.Models
{
    public class DataFilex
    { 
        public int Id { get; set; }
        public string Name { get; set; }
        public string ContentType { get; set; }
        public int UsedCount { get; set; }
    }
}

namespace ALK.Controllers
{
    public class MyController : Controller
    {
        static string Logi = "";
        protected UsedGamesEntities db = new UsedGamesEntities();

        [OutputCache(VaryByParam ="*", Location = System.Web.UI.OutputCacheLocation.ServerAndClient, Duration =3600)]

        public ActionResult Content(int id)
        {
            DateTime s = DateTime.Now;
            DataFile df = db.DataFiles.Find(id);
            if (df == null) return HttpNotFound();
            Logi += $"Laadisin {id} - {(DateTime.Now-s).TotalMilliseconds}\n";
            return File(df.Content, df.ContentType);

        }

        public string GetLogi() => Logi;

        [HttpPost]
        public ActionResult Index(HttpPostedFileBase file)
        {
            if (file != null)
            {
                using (System.IO.BinaryReader br = new System.IO.BinaryReader(file.InputStream))
                {
                    db.DataFiles.Add(
                        new DataFile
                        {
                            Name = file.FileName.Split('\\').Last(),
                            ContentType = file.ContentType,
                            Content = br.ReadBytes(file.ContentLength)
                        }
                        );
                    db.SaveChanges();
                }
            }

            return RedirectToAction("Index");
        }

        public ActionResult Index()
        {
            return View(db.DataFiles.Select(x => new DataFilex {Id =x.Id, Name =x.Name, ContentType = x.ContentType, UsedCount = x.ProductImages.Count } ).ToList());
        }


    }
}

ALK/Controllers/ProductListController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using ALK.Models;
namespace ALK.Models
{
    public class ProductX
    {
        public Product Product { get; set; }
        public int? FirstImageId { get; set; }
    }
}

namespace ALK.Controllers
{
    public class ProductListController : Controller
    {
        private UsedGamesEntities db = new UsedGamesEntities();
        // [OutputCache(VaryByParam = "*", Location = System.Web.UI.OutputCacheLocation.ServerAndClient, Duration = 3600)]

        // GET: ProductList
        public ActionResult Index(int? id)
        {
            if (id == 4)
            {
                id = null;
            }
            var products = db.Products.Where(x => x.Available)
                .Where(x => !id.HasValue || x.CategoryId == id.Value);
            ViewBag.CategoryName = id.HasValue
                ? db.Categories.Find(id.Value)?.Title ?? ""
                : "Kõik tooted";

            products = products.Where(x => x.DefaultImage == null);
            if (id != null) ViewBag.CategoryId = id.Value;
            return View(products.Select(x => new ProductX { Product = x, FirstImageId = x.ProductImages.Select(y => y.ImageId).FirstOrDefault() }).ToList());
        }

        // GET: ProductList/Details/5
        public ActionResult Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Product product = db.Products.Find(id);
            if (product == null)
            {
                return HttpNotFound();
            }

            var item = db.Comments.Where(x => x.ProductId == id).Select(x => x).ToList();
            ViewBag.Comments = item;


            return View(product);
        }

        [Authorize]
        public ActionResult AddComment(int id, string content)
        {
            var auser = ApplicationUser.GetUSer(User.Identity.Name);
            Product p = db.Products.Find(id);
            var item = new Comment()
            {
                ProductId = id,
                Commenter = auser.Id,
                CommentText = content,


            };

            db.Comments.Add(item);
            db.SaveChanges();
            return RedirectToAction("Details/" + id);
        }
        public ActionResult RemoveComment(int id)
        {
            Comment c = db.Comments.Find(id);
            if (c != null)
            {
                db.Comments.Remove(c);
                db.SaveChanges();
            }
            return RedirectToAction("Details");

        }


        // GET: ProductList/Create
        public ActionResult Create()
        {
            ViewBag.UserId = new SelectList(db.AspNetUsers, "Id", "Email");
            ViewBag.CategoryId = new SelectList(db.Categories, "Id", "Title");
            return View();
        }

        // POST: ProductList/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create([Bind(Include = "Id,UserId,Available,ProductName,Description,Price,Created,Starting,PCount,CategoryId,DefaultImage")] Product product)
        {
            if (ModelState.IsValid)
            {
                db.Products.Add(product);
                db.SaveChanges();
                return RedirectToAction("Index");
            }

            ViewBag.UserId = new SelectList(db.AspNetUsers, "Id", "Email", product.UserId);
            ViewBag.CategoryId = new SelectList(db.Categories, "Id", "Title", product.CategoryId);
            return View(product);
        }

        // GET: ProductList/Edit/5
        public ActionResult Edit(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Product product = db.Products.Find(id);
            if (product == null)
            {
                return HttpNotFound();
            }
            ViewBag.UserId = new SelectList(db.AspNetUsers, "Id", "Email", product.UserId);
            ViewBag.CategoryId = new SelectList(db.Categories, "Id", "Title", product.CategoryId);

            if (product.DefaultImage != null) return HttpNotFound();
            return View(product);
        }

        // POST: ProductList/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit([Bind(Include = "Id,UserId,Available,ProductName,Description,Price,Created,Starting,PCount,CategoryId,DefaultImage")] Product product)
        {
            if (ModelState.IsValid)
            {
                db.Entry(product).State = EntityState.Modified;
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            ViewBag.UserId = new SelectList(db.AspNetUsers, "Id", "Email", product.UserId);
            ViewBag.CategoryId = new SelectList(db.Categories, "Id", "Title", product.CategoryId);
            return View(product);
        }

        // GET: ProductList/Delete/5
        public ActionResult Delete(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Product product = db.Products.Find(id);
            if (product == null)
            {
                return HttpNotFound();
            }
            return View(product);
        }

        // POST: ProductList/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id)
        {
            Product product = db.Products.Find(id);
            db.Products.Remove(product);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }

        [Authorize]
        public ActionResult Buy([Bind(Include = "Id,ProductId,UserId,Qty,OrderDate,Description,Delivered,DeliveryDate,DeliveryAddress,PaymentDone,PaymentDate,PaymentAmount")] ProductOrder productOrder, decimal Price, string ProductN, int Count, int ProductId)
        {
            var auser = ApplicationUser.GetUSer(User.Identity.Name);
            var item1 = db.ProductOrders.Where(x => x.UserId == auser.Id).ToList();
            item1 = item1.Where(x => x.ProductId == ProductId).ToList();
            var item2 = item1.Where(x => x.PaymentDone == false).ToList();

            if (item2.Count == 0)
            {

                db.ProductOrders.Add(new ProductOrder
                {
                    ProductId = ProductId,
                    UserId = auser.Id,
                    Qty = 1,
                    OrderDate = DateTime.Now,
                    Delivered = false,
                    PaymentDone = false,
                    PaymentAmount = Price
                });
            }
            else
            {
                productOrder = db.ProductOrders.Find(item2.First().Id);
                productOrder.Qty += 1;
                db.Entry(productOrder).State = EntityState.Modified;

            }

            db.SaveChanges();
            return RedirectToAction("Index");
        }
    }
}

ALK/Views/ProductList/Create.cshtml
@model ALK.Models.Product

@{
    ViewBag.Title = "Create";
}

<h2>Create</h2>


@using (Html.BeginForm()) 
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
        <h4>Product</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        <div class="form-group">
            @Html.LabelFor(model => model.UserId, "UserId", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("UserId", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.UserId, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Available, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                <div class="checkbox">
                    @Html.EditorFor(model => model.Available)
                    @Html.ValidationMessageFor(model => model.Available, "", new { @class = "text-danger" })
                </div>
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.ProductName, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.ProductName, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.ProductName, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Description, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Price, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Price, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Price, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Created, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Created, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Created, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Starting, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Starting, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Starting, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.PCount, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.PCount, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.PCount, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.CategoryId, "CategoryId", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("CategoryId", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.CategoryId, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.DefaultImage, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.DefaultImage, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.DefaultImage, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Create" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

ALK/Views/ProductList/Delete.cshtml
@model ALK.Models.Product

@{
    ViewBag.Title = "Delete";
}

<h2>Delete</h2>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>Product</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.Available)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Available)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.ProductName)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.ProductName)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Description)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Description)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Price)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Price)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Created)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Created)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Starting)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Starting)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PCount)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PCount)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.DefaultImage)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.DefaultImage)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.AspNetUser.Email)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.AspNetUser.Email)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Category.Title)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Category.Title)
        </dd>

    </dl>

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Delete" class="btn btn-default" /> |
            @Html.ActionLink("Back to List", "Index")
        </div>
    }
</div>

ALK/Views/ProductList/Details.cshtml
@model ALK.Models.Product

@{
    ViewBag.Title = "Details";
}

<h2></h2>

<div class="row">
    @foreach (var item in Model.ProductImages)
    {
        <div class="col-lg-3">

            <img src="@Url.Action("Content", "My", new { id = item.ImageId})" style="width:100%" />

        </div>
    }
</div>
<div>
    <h4></h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
        </dt>

        <dd>

        </dd>

        <dt>
            Product Name
        </dt>

        <dd>
            @Html.DisplayFor(model => model.ProductName)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Available)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Available)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Price)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Price)
        </dd>

        <dt>
            Seller
        </dt>

        <dd>
            @Html.DisplayFor(model => model.AspNetUser.DisplayName)
        </dd>

        <dt>
            Category
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Category.Title)
        </dd>
        <dt>
            @Html.DisplayNameFor(model => model.Description)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Description)
        </dd>
        </dd>
    </dl>

    `
</div>

<p>
    <a style="margin-left:350px" class="btn btn-warning" href="@Url.Action("Buy", "ProductList", new { Price = Model.Price, ProductN = Model.ProductName, Count = Model.PCount, ProductId = Model.Id })">Buy</a>
</p>
<p>
    @Html.ActionLink("Back to Products", "Index")
</p>


@using (Html.BeginForm("AddComment", "ProductList", FormMethod.Post))
{
    <label for="Comments">Add Comments</label>
    <input type="hidden" id="id" name="id" value="@Model.Id" />
    <input type="text" id="content" name="content" style="height:35px;width:210px;border-radius:20px;border-color:lightgray;margin-left:15px;margin-right:15px;padding-left:20px;" placeholder="Your Comment" />
    <input type="submit" value="Create" class="btn btn-default" />
    <br>
    <br>
}
<br>
<br>




@foreach (var item in ViewBag.Comments)
{

    <div style="width:500px; height:35px;line-height:30px">
        <p style="margin-left:15px">
            @*<input type="text" name="Commenter"/>*@
            @item.AspNetUser.DisplayName |
            @*<input type="text" name="content" placeholder="Comment" />*@
            @item.CommentText
        </p>
    </div>
}

ALK/Views/ProductList/Edit.cshtml
@model ALK.Models.Product

@{
    ViewBag.Title = "Edit";
}

<h2>Edit</h2>


@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
        <h4>Product</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        @Html.HiddenFor(model => model.Id)

        <div class="form-group">
            @Html.LabelFor(model => model.UserId, "UserId", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("UserId", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.UserId, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Available, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                <div class="checkbox">
                    @Html.EditorFor(model => model.Available)
                    @Html.ValidationMessageFor(model => model.Available, "", new { @class = "text-danger" })
                </div>
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.ProductName, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.ProductName, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.ProductName, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Description, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Price, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Price, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Price, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Created, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Created, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Created, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Starting, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Starting, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Starting, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.PCount, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.PCount, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.PCount, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.CategoryId, "CategoryId", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("CategoryId", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.CategoryId, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.DefaultImage, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.DefaultImage, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.DefaultImage, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Save" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

ALK/Views/ProductList/Index.cshtml
@model IEnumerable<ALK.Models.ProductX>

@{
    ViewBag.Title = "Index";
}

@Html.Action("Index", "Categories", new {CatId = ViewBag.CategoryId })

<h2>@ViewBag.CategoryName</h2>

@using (Html.BeginForm("Edit", "Products", FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    <table class="table">
        <tr>
            <th>

            </th>
            <th>
                Product Name
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Product.Price)
            </th>
            <th></th>
        </tr>

        @foreach (var item in Model)
        {

            <tr>
                <td>
                    <img height="100" src="@Url.Action("Content", "My", new { id = item.FirstImageId   })" />
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Product.ProductName)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Product.Price)
                </td>
                <td>
                    @Html.ActionLink("View", "Details", new { id = item.Product.Id }, new { @class = "btn btn-info" })
                    <a class="btn btn-warning" href="@Url.Action("Buy", "ProductList", new { Price = item.Product.Price, ProductN = item.Product.ProductName, Count = item.Product.PCount, ProductId = item.Product.Id })">Buy</a>
                </td>
            </tr>
        }

    </table>
}